OGRE: Ogre::FrameListener Class Reference - OGRE Documentation

Public Member Functions

# Ogre::FrameListener Class Reference
[General]

A interface class defining a listener which can be used to receive notifications of frame events. More...

`#include <OgreFrameListener.h>`

Inheritance diagram for Ogre::FrameListener:
[legend]

List of all members.

## Public Member Functions
virtual bool | frameStarted (const FrameEvent &evt)
| Called when a frame is about to begin rendering.
virtual bool | frameRenderingQueued (const FrameEvent &evt)
| Called after all render targets have had their rendering commands issued, but before render windows have been asked to flip their buffers over.
virtual bool | frameEnded (const FrameEvent &evt)
| Called just after a frame has been rendered.
virtual | ~FrameListener ()

## Detailed Description

A interface class defining a listener which can be used to receive notifications of frame events.

Remarks:
  A 'listener' is an interface designed to be called back when particular events are called. This class defines the interface relating to frame events. In order to receive notifications of frame events, you should create a subclass of FrameListener and override the methods for which you would like to customise the resulting processing. You should then call Root::addFrameListener passing an instance of this class. There is no limit to the number of frame listeners you can register, allowing you to register multiple listeners for different purposes. Frame events only occur when Ogre is in continuous rendering mode, i.e. after Root::startRendering is called. If the application is doing ad-hoc rendering without entering a rendering loop, frame events are not generated. Note that a frame event occurs once for all rendering targets, not once per target.

Definition at line 82 of file OgreFrameListener.h.

## Constructor & Destructor Documentation

virtual Ogre::FrameListener::~FrameListener | ( |  | ) | `[virtual]`

Definition at line 133 of file OgreFrameListener.h.

## Member Function Documentation

virtual bool Ogre::FrameListener::frameEnded | ( | const FrameEvent & | evt | ) | `[virtual]`

Called just after a frame has been rendered.

Remarks:
  This event happens after all render targets have been fully updated and the buffers switched.

Returns:
  True to continue with the next frame, false to drop out of the rendering loop.

Reimplemented in Ogre::FrameTimeControllerValue, and Ogre::PageManager::EventRouter.

Definition at line 130 of file OgreFrameListener.h.

virtual bool Ogre::FrameListener::frameRenderingQueued | ( | const FrameEvent & | evt | ) | `[virtual]`

Called after all render targets have had their rendering commands issued, but before render windows have been asked to flip their buffers over.

Remarks:
  The usefulness of this event comes from the fact that rendering commands are queued for the GPU to process. These can take a little while to finish, and so while that is happening the CPU can be doing useful things. Once the request to 'flip buffers' happens, the thread requesting it will block until the GPU is ready, which can waste CPU cycles. Therefore, it is often a good idea to use this callback to perform per-frame processing. Of course because the frame's rendering commands have already been issued, any changes you make will only take effect from the next frame, but in most cases that's not noticeable.

Returns:
  True to continue rendering, false to drop out of the rendering loop.

Definition at line 119 of file OgreFrameListener.h.

virtual bool Ogre::FrameListener::frameStarted | ( | const FrameEvent & | evt | ) | `[virtual]`

Called when a frame is about to begin rendering.

Remarks:
  This event happens before any render targets have begun updating.

Returns:
  True to go ahead, false to abort rendering and drop out of the rendering loop.

Reimplemented in Ogre::FrameTimeControllerValue, and Ogre::PageManager::EventRouter.

Definition at line 100 of file OgreFrameListener.h.

The documentation for this class was generated from the following file:

- OgreFrameListener.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:55